'use strict';

/* Controllers */

var app = angular.module('nggrid.controllers', []);
 
// Clear browser cache (in development mode)
//
// http://stackoverflow.com/questions/14718826/angularjs-disable-partial-caching-on-dev-machine

 
app.controller('UserTaskCtrl', function($scope, $modal, $http,UserTaskService,$log) {

	 $scope.filterOptions = {
		filterText: ''
	  };

	  $scope.doSearchTasks = function () {
	     $scope.taskTabl = true;
	     $scope.editT = false; 
		 var url = '/jbpmngmodalwebexample/rest/json/tasks/pending?user='+$scope.user;
		 $scope.taskData = UserTaskService.getUserTaskData(url);
	 }
 
		$scope.editT = false;
		$scope.id = "";
		$scope.name = "";    
		var editContactCellTemplate = '<input type="button" value="Work on Task" ng-click="OnContactEdit(row.entity)"></input>';

			$scope.gridtwoOptions = {
				data: 'taskData',
				multiSelect : false,
				enablePaging: true,
				showFilter: true,
				enableColumnResize: true,
                filterOptions: $scope.filterOptions,
				columnDefs: [{field: 'id', displayName: 'ID', enableCellEdit: false, width: 40, colFilterText: ''},
							 {field:'name', displayName:'Name', enableCellEdit: true, width: 140, colFilterText: '' },
							 {field:'status', displayName:'Status', enableCellEdit: true,width: 90, colFilterText: '' },
							 {field:'processId', displayName:'Process ID', enableCellEdit: true, width:95, colFilterText: '' },
							 {field:'owner', displayName:'Owner', enableCellEdit: true,width: 125, colFilterText: '' },
							 {field:'id', displayName:'Task Action', enableCellEdit: true, width:125,cellTemplate: editContactCellTemplate, colFilterText: ''}]
			};
			
			
			$scope.OnContactEdit = function(value){
       
	            value.user = $scope.user;
				var url = '/jbpmngmodalwebexample/rest/json/tasks/processparams?processId=' +value.processId;
 	            $http.post(url).then(function (res) {
					 value.quantity = res.data.quantity;
					 value.modelNumber = res.data.modelNumber;
					 value.priority = res.data.priority;
					 
			    })
			
				$scope.value = value;
				
				
				var modalInstance = $modal.open({
				  templateUrl: 'partials/nggridmodal.html',		
					
				 controller: NGModalInstanceCtrl,
				  resolve: {
					value: function () {
					  return $scope.value;
					}
				  }
				
				 
				 });
				modalInstance.result.then(function () {
					}, function () {
				  $log.info('Modal dismissed at: ' + new Date());
				});
			};
	
  
});


 var NGModalInstanceCtrl = function ($scope, $modalInstance, value, UserTaskService) {
 
 $scope.value= value;
  
  $scope.ok = function () {

    var url = '/jbpmngmodalwebexample/rest/json/tasks/compleTask?user=' +value.user +'&taskId=' +value.id  +'&priority=' +value.priority +'&modelNumber=' +value.modelNumber +'&quantity=' +value.quantity;
   $scope.taskData  = UserTaskService.getUserTaskData(url);
   
        value.status = 'Completed';
    $modalInstance.close();
  };

  $scope.cancel = function () {
    $modalInstance.dismiss('cancel');
  };
};
//--------------------------------------

app.controller('AdminProcCtrl', function($scope, $http,UserTaskService) {

 
    $scope.CreateProcess = function () {
	
	  $scope.tskState = { show: true }
	  var url = '/jbpmngmodalwebexample/rest/json/tasks/createProcess?' + 'priority=' +$scope.priority +  '&modelNumber=' +$scope.modelNumber +'&quantity=' +$scope.quantity;
	  $scope.procStat = UserTaskService.getUserTaskData(url); 
         
		 if($scope.procStat)
	       $scope.procCreate = {show: true};
    
    }
   });
   
    
